#define CUSTOM_SETTINGS
#define INCLUDE_TERMINAL_MODULE
#include <evive.h>
#include <Dabble.h>

void(* resetFunc)(void) =0;

String Terminaldata ="";
String Tempdata = "";
String password = "evive";

#define servo_pin 44

Servo locker_servo;

void setup() 
   {
       // put your setup code here, to run once:

       Serial.begin(250000);
       Dabble.begin(115200);

      locker_servo.attach(servo_pin);

       locker_servo.write(135);

        tft_init(INITR_GREENTAB);
        tft.setRotation(1);
        tft.fillScreen(ST7735_BLACK);

       tft.setCursor(25,10);
       tft.setTextSize(2);
       tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
       tft.print("STEMpedia");

       tft.setCursor(25,30);
       tft.setTextSize(1.8);
       tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
       tft.print("DABBLE CONTROLLED");
       tft.setCursor(35,40);
       tft.print(" DOOR LOCKER");

       tft.setCursor(55,60);
       tft.setTextSize(1.8);
       tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
       tft.print("STATUS");

       tft.setCursor(25,70);
       tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
       tft.print("DOOR :   ");
       tft.setTextColor(ST7735_BLUE,ST7735_BLACK);
       tft.print(" CLOSE "); 


       tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
       tft.setCursor(0,105);
       tft.setTextSize(1.8);
       tft.print("FOR MORE INFORMATION VISIT");
       tft.setCursor(30,115);
       tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
       tft.print("thestempedia.com");

    }

void loop()
    {
       // put your main code here, to run repeatedly: 
        Dabble.processInput();
        while(Terminal.available()==0)
        {
           Dabble.processInput();
        }
        while (Terminal.available() != 0)
           {
              Terminaldata = String(Terminaldata + char(Terminal.read()));
           }
           delay(2);
           Serial.println(Terminaldata);
           if(Terminaldata=="open the door")
              {
                 Terminal.print("Please enter your password ");
                 delay(2);
                 while(Terminal.available()==0)
                     {
                         Dabble.processInput();
                     }
                 while (Terminal.available() != 0)
                     {
                         Tempdata = String(Tempdata+char(Terminal.read()));
                     }
                 delay(2);
                 if(Tempdata==password)
                    {
                        locker_servo.write(0);
                        tft.setCursor(25,70);
                        tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
                        tft.print("DOOR :   ");
                        tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
                        tft.print(" OPEN    "); 
                        Terminal.print(" Access Granted ");
                        Terminal.print(" Welcome evive ");
                        delay(7000);
                        resetFunc();
                        
                    }
                 else
                    {
                    
                        Terminal.print(" Access denied ");
                        locker_servo.write(135);
                        resetFunc();
                        
                    }
                  delay(2);
           }
           else 
           {
              Terminal.print("try again ");
              locker_servo.write(135);
              resetFunc();
           }

             Tempdata = "";
             Terminaldata= "";
    }
